clear
nb = 1;   % 3 17 5 54% 2 42

%qaz = 'Brighton';
%qaz = 'Eddystone Point';
%qaz = 'Luncheon Hill';
%qaz = 'Lilydale';
qaz = 'Hobart';
%qaz = 'Write Beach';

adj = 0;

area_num_2 = 100;
area_num_ad = 0;  %100;

lat_wind = readmatrix('lat_wind.csv');
lon_wind = readmatrix('lon_wind.csv');

TT = readmatrix('wind2.csv');
T_T = sortrows(TT,-6);

TTT = readcell('wind2.csv');
TTTT = TTT(2:end,:);
TTTTT = sortrows(TTTT,-6);
T_time = TTTTT(nb,1);
T_time = [T_time{:}];

lat_position = find(lat_wind >= T_T(nb,3)-min(abs(lat_wind-T_T(nb,3))) & lat_wind <= T_T(nb,3)+min(abs(lat_wind-T_T(nb,3))));
lon_position = find(lon_wind >= T_T(nb,4)-min(abs(lon_wind-T_T(nb,4))) & lon_wind <= T_T(nb,4)+min(abs(lon_wind-T_T(nb,4))));

y = year(T_time);
m = month(T_time);
d = day(T_time);
h = hour(T_time)+1+adj;
h3 = hour(T_time)+adj;
f = minute(T_time);
if h <= 23 
    if f >= 30
        h = h+1;
        h3 = h3+1;
    end
else
        d = d+1;
        h = 0;
end

lat_wind = readmatrix('lat_wind.csv');
lon_wind = readmatrix('lon_wind.csv');

time_h = rem(h3,6)+1;
time_hh = (h3+1-time_h)/6+1;
time_e = ["0000" "0600" "1200" "1800"];
h2 = time_e(time_hh);

y = num2str(y,'%04d');
m = num2str(m,'%02d');
d = num2str(d,'%02d');
h = num2str(h2,'%04d');
h3 = num2str(h3,'%02d');

T = time_h;    
T_NUM = num2str(T,'%02d');

%% Reading the data directly

% the Hobart airport (lat -42.83 / lon 147.50) --> (lat,lon)--> (236,372)
year = y;   
month = m ;
day = d ; 
time = h ;     % '0000'; '0600'; '1200'; '1800';
variable = 'vertical_wnd';    %'vertical_wnd'; 'wnd_ucmp'; 'wnd_vcmp'; 'air_temp'; 'relhum'; 'pressure'; 'geop_ht'; 'time'; 
region ='BARRA_TA' ;    % 'BARRA_TA';     'BARRA_R';
station = 'prs' ;      
%lat_p =  236   ;         % 1-508 
%lon_p =  372   ;         % 1-594
lat_p =  lat_position ;         % 1-508
lon_p =  lon_position ;         % 1-594
T = time_h; 
area_num = 5;

filePath_max_wndgust10m = ['/Volumes/Backup_Plus/BARRA_TA/','max_wndgust10m/',year,'/',month,'/','max_wndgust10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
time_c= ncread(filePath_max_wndgust10m,'time'); 
filePath_uwnd10m = ['/Volumes/Backup_Plus/BARRA_TA/','uwnd10m/',year,'/',month,'/','uwnd10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_vwnd10m = ['/Volumes/Backup_Plus/BARRA_TA/','vwnd10m/',year,'/',month,'/','vwnd10m-fc-spec-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
U_uwnd10m = ncread (filePath_uwnd10m,'uwnd10m');
V_vwnd10m = ncread (filePath_vwnd10m,'vwnd10m');
U1 = permute(U_uwnd10m,[2 1 3]);
V1 = permute(V_vwnd10m,[2 1 3]);

max_wndgust10m = ncread(filePath_max_wndgust10m,'max_wndgust10m');
max_wndgust10m = permute(max_wndgust10m,[2 1 3]);

%%
filePath_vertical_wnd = ['/Volumes/Backup_Plus/BARRA_TA/','vertical_wnd/',year,'/',month,'/','vertical_wnd-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_wnd_ucmp = ['/Volumes/Backup_Plus/BARRA_TA/','wnd_ucmp/',year,'/',month,'/','wnd_ucmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
filePath_wnd_vcmp = ['/Volumes/Backup_Plus/BARRA_TA/','wnd_vcmp/',year,'/',month,'/','wnd_vcmp-fc-',station,'-PT1H-',region,'-v1-',year,month,day,'T',time,'Z','.sub.nc'];
height = ncread('/Volumes/Backup_Plus/BARRA_TA/geop_ht/2014/01/geop_ht-fc-prs-PT1H-BARRA_TA-v1-20140101T0000Z.sub.nc','geop_ht');

W_wind = ncread(filePath_vertical_wnd,'vertical_wnd');
P_wind = ncread (filePath_vertical_wnd,'pressure');
W = permute(W_wind,[2 1 3 4]);
% Vertical wind profile

y2 = squeeze(W(lat_p,lon_p,:,T));
x2 = squeeze(P_wind);
width = 2;
figure(5);
h = barh(x2,y2,width,'b');
set(gca,'YDir','reverse'); 
xlabel('Wind speed (m/s)');
ylabel('Pressure (hPa)');
xtips1 = h.YEndPoints + 0.3;
ytips1 = h.XEndPoints;
labels1 = string(h.YData);
%text(xtips1,ytips1,labels1,'VerticalAlignment','middle');

%%
format short g
time_c = double(time_c);

ti = 10;
U_wind = ncread (filePath_wnd_ucmp,'wnd_ucmp');
V_wind = ncread (filePath_wnd_vcmp,'wnd_vcmp');
U = permute(U_wind,[2 1 3 4]);
V = permute(V_wind,[2 1 3 4]);
UU = squeeze(U(lat_p,lon_p-ti:lon_p+ti,:,T))';
VV = squeeze(V(lat_p-ti:lat_p+ti,lon_p,:,T))';
WW1 = squeeze(W(lat_p,lon_p-ti:lon_p+ti,:,T))';
WW2 = squeeze(W(lat_p-ti:lat_p+ti,lon_p,:,T))';
height1 = squeeze(height(lat_p,lon_p,:,T));

UUU = squeeze(U(lat_p-ti:lat_p+ti,lon_p-ti:lon_p+ti,:,T));
VVV = squeeze(V(lat_p-ti:lat_p+ti,lon_p-ti:lon_p+ti,:,T));
WWW = squeeze(W(lat_p-ti:lat_p+ti,lon_p-ti:lon_p+ti,:,T));

%[x3,y3] = meshgrid(lon_wind(lon_p-ti:lon_p+ti),P_wind(:,1));
%[x3,y3] = meshgrid(lon_wind(lon_p-ti:lon_p+ti),height1);
[x3,y3] = meshgrid(0:1:2*ti,22:-1:0);
[x4,y4,z4] = meshgrid(0:1:2*ti,0:1:2*ti,20:-1:0);

[x5,y5] = meshgrid(0:1:2*ti,22);
u_rf=zeros(1,2*ti+1);
v_rf=zeros(1,2*ti+1);
u_rf(1,ti+4) = 30;

figure(8)
quiver([x5;x3(3:2*ti+3,:)],[y5;y3(3:2*ti+3,:)],[u_rf;UU],[v_rf;WW1],'k');
ylim([-1,23]);
xlim([-1,21]);
set(gca,'YTick',[0:1:20]);
set(gca,'XTick',[0:2:20]);
text(ti+5,22,'Arrow scale: 30m/s')
hold on;
plot(ti,-1,'ro','linewidth',2,'MarkerSize',15)
set(gca,'YTickLabel',{'1000','975','950','925','900','850','800','700','600','500','400','300','250','200','150','100','70','50','30','20','10'});
set(gca,'XTickLabel',num2cell(lon_wind(lon_p-ti:2:lon_p+ti))');
xlabel('Longitude (E^{?})');
ylabel('Pressure (hPa)');

transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name222 = ['Wind profile along longitude(E^{.}) in ',qaz,' ',transfer_time_1 ,'\rm', char(10)];
title_name = ['Wind profile along longitude(E^{?}) in ',qaz,' ',transfer_time_1 ,'\rm', char(10)];
title(title_name);
ax = gca;
ax.FontSize = 13;

figure(9)

quiver([x5;x3(3:2*ti+3,:)],[y5;y3(3:2*ti+3,:)],[u_rf;VV],[v_rf;WW2],'k');
ylim([-1,23]);
xlim([-1,21]);
set(gca,'YTick',[0:1:20]);
set(gca,'XTick',[0:2:20]);
text(ti+5,22,'Arrow scale: 30m/s')
hold on;
plot(ti,-1,'ro','linewidth',2,'MarkerSize',15)
set(gca,'YTickLabel',{'1000','975','950','925','900','850','800','700','600','500','400','300','250','200','150','100','70','50','30','20','10'});
set(gca,'XTickLabel',num2cell(-lat_wind(lat_p-ti:lat_p+ti))');
xlabel('Latitude (S^{?})');
ylabel('Pressure (hPa)');

transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Wind profile along Latitude(S^{?}) in ',qaz,' ',transfer_time_1 ,'\rm', char(10)];
title(title_name);
ax = gca;
ax.FontSize = 13;

%%
name_S = ['DCAPE_S',y,m,d,h3,T_NUM,'.csv'];
name_L = ['DCAPE_L',y,m,d,h3,T_NUM,'.csv'];
DCAPE_num_S = readmatrix(name_S);
%DCAPE_num_L = readmatrix(name_L);
area_num = 100;
%PLOT THE SMALL DCAPE

addpath('/Users/Mac/Documents/m_map')
range_lat = (lat_p-area_num:lat_p+area_num);
range_lon = (lon_p-area_num:lon_p+area_num);
clon1 = [lon_wind(lon_p-area_num) lon_wind(lon_p+area_num)];
clat1 = [lat_wind(lat_p-area_num) lat_wind(lat_p+area_num)];

format short g
time_c = double(time_c);
time = zeros(6,1);

figure(1); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

for time_8 = 1:6
    subplot(2,3,time_8);
       m_contourf(lon_wind(range_lon),lat_wind(range_lat),DCAPE_num_S(:,(time_8-1)*(area_num*2+1)+1:time_8*(area_num*2+1)))
       caxis([200 1400])
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       m_plot(double(lon_wind(lon_p)),double(lat_wind(lat_p)),'ro','linewidth',2,'MarkerSize',15);
       time(time_8) = vpa(time_c(time_8)/24,8);
       transfer_time = datetime(time(time_8) + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       
       titlelin2=['  DCAPE=',num2str(DCAPE_num_S(area_num+1,area_num+1+(time_8-1)*201)),' J/Kg','  maxwndgust10m =',num2str(max_wndgust10m(lat_position,lon_position,time_8)),' m/s'];
       title_name = ['Downdraft CAPE at ',qaz,' ',transfer_time_1];
       title([ title_name '\rm' char(10) titlelin2]);  

end

%%
%PLOT THE middle DCAPE

area_num = area_num_2;

addpath('/Users/Mac/Documents/m_map')
range_lat = (lat_p-area_num-2*area_num_ad:lat_p+area_num);
range_lon = (lon_p-area_num-area_num_ad:lon_p+area_num+area_num_ad);
clon1 = [lon_wind(lon_p-area_num-area_num_ad) lon_wind(lon_p+area_num+area_num_ad)];
clat1 = [lat_wind(lat_p-area_num-2*area_num_ad) lat_wind(lat_p+area_num)];

format short g
time_c = double(time_c);
time = zeros(6,1);

time_8 = T;

figure(2); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       %m_contourf(lon_wind,lat_wind,wind_10m(:,:,time_8));
       m_pcolor(lon_wind(range_lon),lat_wind(range_lat),max_wndgust10m(range_lat,range_lon,T));
       caxis([0 30])
       %shading interp; 
       colorbar;
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       m_plot(double(lon_wind(lon_p)),double(lat_wind(lat_p)),'ro','linewidth',2,'MarkerSize',15);
       
       %m_quiver(X1(lat_p,lon_p,21),Y1(lat_p,lon_p,21),uwnd10m(lat_p,lon_p,T),vwnd10m(lat_p,lon_p,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['max wind gust 10m above the ground at ',qaz,' ',transfer_time_1,'\rm', char(10)];
%hobart  148 Brighton white beach 195 Queenstown %text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
       title(title_name);
       ax = gca;
       ax.FontSize = 13;
       
%% According to presures -- coastline 2

lon_wind = ncread (filePath_max_wndgust10m,'longitude');
lat_wind = ncread (filePath_max_wndgust10m,'latitude');
[X1,Y1,Z1] = meshgrid(lon_wind,lat_wind,21);

range_ad = 100;  % 4
%clat=[-42.57775-407/119 -42.57775+407/119];  clon=[146.50325-1457/364 146.50325+1457/364]; % Barkley Sound
%clat=[-42.83-81/60 -42.83+151/60];  clon=[147.5-181/60 147.5+151/60]; % Barkley Sound
clat=[double(lat_wind(lat_p-range_ad)) double(lat_wind(lat_p+range_ad))];  
clon=[double(lon_wind(lon_p-range_ad)) double(lon_wind(lon_p+range_ad))]; % Barkley Sound

addpath('/Users/Mac/Documents/m_map')
fname = ['/Volumes/Backup_Plus/BARRA_TA/topog/topog-fc-slv-PT0H-BARRA_TA-v1.nc'];

range_lat = (lat_p-range_ad+15:6:lat_p+range_ad);
range_lon = (lon_p-range_ad+5:6:lon_p+range_ad-10);
%range_lat = (160:8:508);
%range_lon = (1:8:540);

[x1,y1] = meshgrid(lon_wind,lat_wind(lat_p-90));
u_rf=zeros(1,594);
v_rf=zeros(1,594);

u_rf(1,lon_p-80:lon_p-80+4) = 15;
u_rf(1,lon_p+10:lon_p+10+4) = 30;

pres = 21;

lon = ncread (filePath_max_wndgust10m,'longitude');
lat = ncread (filePath_max_wndgust10m,'latitude');

ilat=lat>=clat(1) & lat<=clat(2);
ilon=lon>=clon(1) & lon<=clon(2);
Z=ncread(fname,'topog',[ find((ilon),1,'first') find((ilat),1,'first')],...
                       [ sum(ilon) sum(ilat)],[1 1]);
figure(3);

m_proj('equidistant','lon',clon,'lat',clat);   % Projection

m_contourf(lon(ilon),lat(ilat),Z',[-50:25:-25 0.1 50:50:200 300:100:1400 1450],'edgecolor','none');
%shading flat;

caxis([-50 1450]);   
 
colormap([m_colmap('blues',3);m_colmap('gland',128)]);

m_grid('box','fancy','tickdir','out','grid','none','fontsize',14);
hold on
%m_coast('line','color',[1 .85 .7],'LineWidth',2);
%hold on 
%qp = m_quiver(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),U(range_lat,range_lon,pres,T),V(range_lat,range_lon,pres,T),'k');
qp = m_quiver([x1(1,range_lon);X1(range_lat,range_lon)],[y1(1,range_lon);Y1(range_lat,range_lon)],[u_rf(1,range_lon);U1(range_lat,range_lon,T)],[v_rf(1,range_lon);V1(range_lat,range_lon,T)],'k');
%Finally some text is included:
set(qp,'LineWidth',0.9,'MaxHeadSize',.1,'Color','black')
%set(qp,'LineWidth',2,'MaxHeadSize',.1,'AutoScaleFactor',1,'Color','black')

m_text(double(lon_wind(lon_p+25)),double(lat_wind(lat_p-90)),'Arrow scale: 30m/s')
m_text(double(lon_wind(lon_p-65)),double(lat_wind(lat_p-90)),'Arrow scale: 15m/s')

hold on
ax = m_contfbar( .95,[.3 .7], Z',[-300:25:-25 0.1 50:50:200 300:100:1400 1450],...
           'axfrac',.02,'endpiece','no','levels','match');  
       %ax=m_contfbar([.3 .7],.05,CS,CH);
ax.YLabel.String='Topographic height m';
       set(ax,'fontsize',10)
hold on

m_plot(double(lon_wind(lon_p)),double(lat_wind(lat_p)),'ro','linewidth',2,'MarkerSize',15)

%[cs,h]=m_contour(X1(range_lat,range_lon,pres),Y1(range_lat,range_lon,pres),air_temp_1(range_lat,range_lon,pres,T),'color','k');
%clabel(cs,h,'LineWidth',1.5,'fontsize',8);

transfer_time = datetime(time_c(T)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
transfer_time_1 = datestr(transfer_time);

if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
end
title_name = ['Wind 10m above the ground at ',qaz,' ',transfer_time_1 ,'\rm', char(10)];
%hobart  148 Brighton white beach 195 Queenstown %text(min(xlim),max(ylim),' b)','fontweight','bold','verticalalignment','top','fontsize',20);
title(title_name);
ax = gca;
ax.FontSize = 13;
%colormap(flipud(m_colmap('Blue',256)))

%set(m_bar, 'Position', [.3 .01 .4150 .005]);
       
%%

figure(4); 
clf

m_proj('lambert','lon',clon1,'lat',clat1);

       m_contourf(lon_wind(range_lon),lat_wind(range_lat),DCAPE_num_L(range_lat,range_lon))
       caxis([200 1400])
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       shading interp;
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       time(T) = vpa(time_c(T)/24,8);
       transfer_time = datetime(time(T) + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       
       titlelin2=['  DCAPE=',num2str(DCAPE_num_L(lat_p,lon_p)),'  maxwndgust10m =',num2str(max_wndgust10m(lat_position,lon_position,T))];
       title_name = ['Downdraft CAPE at Tasmaina ',transfer_time_1];
       title([ title_name '\rm' char(10) titlelin2]);  


%% Plotting the DCAPE MAP & WIND_10

addpath('/Users/Mac/Documents/m_map')
clon = [lon_wind(1) lon_wind(end)];
clat = [lat_wind(1) lat_wind(end)];

figure(4); 
clf

m_proj('lambert','lon',clon,'lat',clat);
%m_proj('oblique','lat',clat,'lon',clon,'aspect',.8);
%m_proj('equidistant','lon',clon,'lat',clat); 

time_8 = T;
   subplot(1,2,1);
       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       m_contourf(lon_wind,lat_wind,DCAPE_num_L(:,:));
       caxis([200 1400])
       %shading interp; 
       colorbar('Ticks',[200 400,600,800,1000,1200,1400],...
         'TickLabels',{'200','400','600','800 -Decent','1000 -Significant downburst','1200 -Wind Damage',1400});
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       %m_quiver(X1(:,:,21),Y1(:,:,21),uwnd10m(:,:,T),vwnd10m(1:end-1,:,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['Downdraft CAPE at Tasmaina ',transfer_time_1];
       title(title_name);
       ax = gca;
       ax.FontSize = 15;
       
   subplot(1,2,2);
       %m_coast('patch',[1 .85 .7],'edgecolor','none');
       %m_elev('contourf',[0:50:1000]);
       %hold on;
       %m_contourf(lon_wind,lat_wind,wind_10m(:,:,time_8));
       m_pcolor(lon_wind,lat_wind,max_wndgust10m(:,:,T));
       caxis([0 35])
       %shading interp; 
       colorbar;
       m_grid('box','fancy','tickdir','in');
       m_coast('line','color',[1 .85 .7],'LineWidth',2);
       hold on;
       
       %m_quiver(X1(lat_p,lon_p,21),Y1(lat_p,lon_p,21),uwnd10m(lat_p,lon_p,T),vwnd10m(lat_p,lon_p,T),'k');
              
       transfer_time = datetime(time_c(time_8)/24 + datenum(1970,1,1)-4/24,'ConvertFrom','datenum');
       transfer_time_1 = datestr(transfer_time);
       if strlength(transfer_time_1) <20
            transfer_time_1 = [transfer_time_1, ' 00:00:00'];
       end
       title_name = ['max wind gust 10m above the ground at Tasmaina ',transfer_time_1];
       title(title_name);
       ax = gca;
       ax.FontSize = 15;

%%
clearvars
%clearvars -except DCAPE_num